<template>
  <div class="navbar bg-base-100 w-100 shadow-md">
    <div class="navbar-start">
      <button class="btn btn-ghost btn-circle" @click="toggleDarkMode">
        <span class="material-symbols-outlined">{{ (dataTheme === 'dark') ? 'dark_mode' : 'light_mode' }}</span>
      </button>
    </div>
    <!--<div class="navbar-center text-xl font-bold">Green IFTTT</div>-->
    <div class="navbar-center flex flex-row">
      <img :src="logo" alt="logo" class="h-16 w-16" />
      <h1 class="text-sm font-bold" style="color: #52b888;">Green<br/>IFTTT</h1>
    </div>
    <div class="navbar-end">
      <button class="btn btn-ghost btn-circle" :disabled="loading" @click="addAdvice">
        <span v-if="loading" class="loading loading-ring loading-sm"></span>
        <span v-if="!loading" class="material-symbols-outlined">lightbulb</span>
      </button>
      <button v-if="isAdvicesRoute" class="btn btn-success btn-circle" @click="goToAdvices">
        <span class="material-symbols-outlined">{{ newAdvice ? 'notifications_unread' : 'notifications' }}</span>
      </button>
      <button v-else class="btn btn-ghost btn-circle" @click="goToAdvices">
        <span class="material-symbols-outlined">{{ newAdvice ? 'notifications_unread' : 'notifications' }}</span>
      </button>
      <button class="btn btn-ghost btn-circle" v-if="logged" @click="logout">
        <span class="material-symbols-outlined">logout</span>
      </button>
    </div>
  </div>
</template>

<script>
  import store from '@/store';
  import logo from '@/assets/logo.png';

  export default {
    data() {
      return {
        dataTheme: store.defaultDarkMode,
        logged: false,
        logo: logo,
        loading: false,
        newAdvice: false,
        isAdvicesRoute: false,
      };
    },
    methods: {
      logout(){
        store.resetUserToken()
        window.location.reload();
        // this.$router.push("/")
      },
      toggleDarkMode() {
        this.dataTheme = store.toggleDarkMode()
      },
      addAdvice() {
        var self = this;
        self.loading = true;
        self.$axios.post('/advices')
        .then(async function (response) {
            console.log(response);
            self.$toast.success("Advice added successfully, you can read it in the Home section");
        })
        .catch(function (error) {
            self.$toast.error(error.response.data.message);
        })
        .finally(function () {
            self.loading = false;
            self.newAdvice = true;
        });
      },
      goToAdvices() {
        this.newAdvice = false;
        this.$router.push("/advices");
      }
    },
    mounted() {
      this.dataTheme = store.getDarkMode();
      document.documentElement.setAttribute('data-theme', this.dataTheme);
      this.logged = store.getUserToken() != null;
      // Check if the current route is /devices
      this.isDevicesRoute = this.$route.path === '/advices';
    },
    watch: {
      // Watch for route changes and update isDevicesRoute accordingly
      $route(to, from) {
        this.isAdvicesRoute = to.path === '/advices';
      },
    },
  };
</script>

<style>
  .navbar{
    position: fixed;
    top: 0;
    left: 0;
    right: 0;
    z-index: 100;
  }
</style>